/* GFE -- GNU Font Editor
 * Copyright (C) 2000 Anuradha Ratnaweera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GFE_BITMAP_H__
#define __GFE_BITMAP_H__

#include <gtk/gtk.h>

/* No type casting is necessary for GfeBitmap therefore a macro
 * GFE_BITMAP(bitmap) is not defined. See structures.txt. */

/* GfeBitmap is used to hold simple 1 bit bitmap */

typedef struct _GfeBitmap GfeBitmap;

struct _GfeBitmap {
  int width, height;
  guint8 **data;
};

/* global function declarations */

GfeBitmap *gfe_bitmap_new(void);
int gfe_bitmap_allocate(GfeBitmap *bitmap, int width, int height);
void gfe_bitmap_free(GfeBitmap *bitmap);
void gfe_bitmap_clear(GfeBitmap *bitmap);
void gfe_bitmap_destroy(GfeBitmap *bitmap);
void gfe_bitmap_set_bit(GfeBitmap *bitmap, int column, int row);
void gfe_bitmap_set_byte(GfeBitmap *bitmap, int column, int row, guint8 value);
void gfe_bitmap_unset_bit(GfeBitmap *bitmap, int column, int row);
gboolean gfe_bitmap_get_bit(GfeBitmap *bitmap, int column, int row);

#endif /* !__GFE_BITMAP_H__ */
