/* GFE -- GNU Font Editor
 * Copyright (C) 2000 Anuradha Ratnaweera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GFE_GLYPH_H__
#define __GFE_GLYPH_H__

#include <gtk/gtk.h>
#include <values.h>

/* macro for type casting */
#define GFE_GLYPH(glyph) ((GfeGlyph*)(glyph))

/* constant for undefined value of encoding */
#define GFE_GLYPH_NO_ENCODING (-1)

/* constant used to define undefined status of variables */
#define GFE_UNDEFINED         (MAXINT)

/* macro(s) to access member(s) of GfeGlyph structure */
#define GFE_GLYPH_TYPE(glyph)     (((glyph)->flags) & 0xFF)

/* GfeGlyph is the generic font type from which all the other font
 * types are derived. */

typedef struct _GfeGlyph GfeGlyph;

struct _GfeGlyph {
  /* first 8 bits of flags will be used for font type */
  int flags;
  char *name;
  int encoding;
  GfeGlyph *next;
  GfeGlyph *previous;
};

/* global function declarations */
/* should be called only from within child structures */

void gfe_glyph_init(GfeGlyph *glyph);
void gfe_glyph_set_type(GfeGlyph *glyph, guint8 type);
int gfe_glyph_set_name(GfeGlyph *glyph, char *name);
void gfe_glyph_free(GfeGlyph *glyph);

#endif /* !__GFE_GLYPH_H__ */
