/* GFE -- GNU Font Editor
 * Copyright (C) 2000 Anuradha Ratnaweera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "gui.h"
#include "file.h"
#include "init.h"

/* Creates the GUI for GFE and returns nonzero in case of failure.
 * Then attempts to open the file list given by gfe_argv (gfe_argc in
 * number), one by one. If opening fails, it's upto file_open()
 * to generate an error message. Retures zero on success, even if
 * opening the file list fails. */
int
gfe_init(int gfe_argc, char *gfe_argv[])
{  
  if (create_gui())
    return -1;

  if (gfe_argc > 0) {
    while (gfe_argc--) {
      if (*gfe_argv)
        file_open(*gfe_argv, 0);
      gfe_argv++;
    }
  }

  return 0;
}

