/* GFE -- GNU Font Editor
 * Copyright (C) 2000 Anuradha Ratnaweera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GFE_RASTER_FONT_H__
#define __GFE_RASTER_FONT_H__

#include "font.h"

/* macro for type casting */
#define GFE_RASTER_FONT(font) ((GfeRasterFont*)(font))

/* GfeRasterFont is derived from GfeFont, and is used to store
 * bitmap based fonts. */

typedef struct _GfeRasterFont GfeRasterFont;

struct _GfeRasterFont {
  GfeFont font;
  int point_size;
  int x_resolution;
  int y_resolution;
  int bbx_width;
  int bbx_height;
  int bbx_x_offset;
  int bbx_y_offset;
  int metricsset;
  float sw_x;
  float sw_y;
  int dw_x;
  int dw_y;
  float sw1_x;
  float sw1_y;
  int dw1_x;
  int dw1_y;
  int vv_x;
  int vv_y;
  int num_properties;
  char **property;
  char **value;
};

/* global function declarations */

GfeRasterFont *gfe_raster_font_new(void);
void gfe_raster_font_free(GfeRasterFont *font);
void gfe_raster_font_destroy(GfeRasterFont *font);

#endif /* !__GFE_RASTER_FONT_H__ */
