/* GFE -- GNU Font Editor
 * Copyright (C) 2000 Anuradha Ratnaweera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GFE_RASTER_GLYPH_H__
#define __GFE_RASTER_GLYPH_H__

#include <gtk/gtk.h>

#include "bitmap.h"
#include "glyph.h"
#include "raster_font.h"

/* macro for type casting */
#define GFE_RASTER_GLYPH(glyph) ((GfeRasterGlyph*)(glyph))

/* GfeRasterGlyph is derived from GfeGlyph and is used to store
 * bitmap based glyphs. */

typedef struct _GfeRasterGlyph GfeRasterGlyph;

struct _GfeRasterGlyph {
  GfeGlyph glyph;
  float sw_x;
  float sw_y;
  int dw_x;
  int dw_y;
  float sw1_x;
  float sw1_y;
  int dw1_x;
  int dw1_y;
  int vv_x;
  int vv_y;
  int bbx_width;
  int bbx_height;
  int bbx_x_offset;
  int bbx_y_offset;
  GfeBitmap *bitmap;
};

/* global function declarations */

GfeRasterGlyph *gfe_raster_glyph_new(GfeRasterFont *font);
void gfe_raster_glyph_destroy(GfeRasterGlyph *glyph);
void gfe_raster_glyph_free(GfeRasterGlyph *glyph);
int gfe_raster_glyph_copy_to_font(GfeRasterGlyph *glyph, GfeRasterFont *font);
int gfe_raster_glyph_copy_from_font(GfeRasterFont *font, GfeRasterGlyph *glyph);

#endif /* !__GFE_RASTER_GLYPH_H__ */
