/* GFE -- GNU Font Editor
 * Copyright (C) 2000 Anuradha Ratnaweera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <gtk/gtk.h>

/* Global functions */

/* Creates a button with a pixmap created from XPM_DATA and the text
 * LABEL and returns the button. */
GtkWidget *xpm_label_button(GtkWidget *parent, gchar **xpm_data,
		            gchar *label_text)
{
  GtkWidget *button;
  GtkWidget *box;
  GtkWidget *label;
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkStyle *style;

  button = gtk_button_new();

  box = gtk_hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(button), box);
  gtk_container_set_border_width(GTK_CONTAINER(box), 2);
  style = gtk_widget_get_style(parent);
  pixmap = gdk_pixmap_create_from_xpm_d(parent->window, &mask,
                                        &style->bg[GTK_STATE_NORMAL],
                                        xpm_data);
  pixmapwid = gtk_pixmap_new(pixmap, mask);
  gtk_box_pack_start(GTK_BOX(box), pixmapwid, FALSE, FALSE, 3);
  gtk_widget_show(pixmapwid);

  label = gtk_label_new (label_text);
  gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  gtk_widget_show(box);

  return(button);
}

/* Creates a pixmap from XPM_DATA, and a button, packs the pixmap into
 * the button, and returns a pointer to the button. Show the pixmap
 * but not the button. */
GtkWidget
*xpm_button(GtkWidget *window, gchar **xpm_data)
{
  GtkWidget *button, *pixmapwid;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkStyle *style;

  style = gtk_widget_get_style(window);
  pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
		  &style->bg[GTK_STATE_NORMAL],
		  (gchar **)xpm_data);

  pixmapwid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmapwid);
  button = gtk_button_new();
  gtk_container_add(GTK_CONTAINER(button), pixmapwid);

  return (button);
}

